#include	"dxchange.h"
#include	"config.h"

void		ReConnectSet(void);
void		BeaconSend(void);
void        	AprsUserPassSend (void);
int     	passcode(char callsign[]);
void   		Beacon_Send(struct Beacon *pnt);
void     	dprs_message (char string[]);

enum
{
	DPRS_OPEN_AUTOLINK_START = 0,
	DPRS_OPEN_AUTOLINK_RESTART,
	DPRS_OPEN_AUTOLINK,
	DPRS_OPEN_DONE_AUTOLINK,
	DPRS_OPEN_AUTOLINK_WAIT,
	DPRS_ACCEPT,
	DPRS_LOOP,
	DPRS_NG
} DprsState = DPRS_OPEN_AUTOLINK_START;

time_t	AprsKeepAlive;
time_t	AprsConnectTime;
time_t	AprsVerifyTime;
time_t	Timer;

int     ReDprsConnectCnt = 0;
int     ReDprsConnectCount = 0;
int	aprs_status;
int	DprsTempPnt;

void	aprs (void)
{
	struct	addrinfo	hints;
	int			err;
	char	PORT[8];

	time_t	atime;
	int	len;
	char	*tp;
	struct	Beacon	*next_beacon;

	switch (DprsState)
	{
		case DPRS_LOOP:
               		time(&atime);
               		if (FD_ISSET (aprs_sd, &read_set))      // from aprs server
               		{
                       		len = recvfrom (aprs_sd, DprsTemp, sizeof(DprsTemp),
                              			 0, NULL, NULL);
                       		if (len <= 0) 
				{
					ReConnectSet();
				}
                       		else
                       		{
					if (len == sizeof(DprsTemp)) len--;
                               		DprsTemp[len] = 0x00;
                                        if (debug_sw)
                                        {
                                                fprintf (log_file, "%24.24s %s", ctime(&atime), DprsTemp);
                                                fflush (log_file);
                                        }
                               		if (!memcmp (DprsTemp, "# logresp", 9))
                               		{
                                       		tp = strtok (DprsTemp, " \r\n\0");
						tp = strtok (NULL, " \r\n\0");
						tp = strtok (NULL, " \r\n\0");
						tp = strtok (NULL, " \r\n\0");		// "verified." or "unverified"
						verify_sw = FALSE;
						if (!memcmp(tp, "verified", 8)) verify_sw = TRUE;
						tp = strtok (NULL, " \r\n\0");		// "server"
						tp = strtok (NULL, " \r\n\0");		// server name
                                       		memcpy (aprs_server , tp, strlen(tp));
						time (&atime);
						if (verify_sw)
							fprintf (log_file, "%24.24s APRS Server (%s) Verified.\n", 
								ctime(&atime), aprs_server);
						else
							fprintf (log_file, "%24.24s APRS Server (%s) Unverified.\n", 
								ctime(&atime), aprs_server);
						fflush (log_file);
                               		}
					else
						dprs_message(DprsTemp);

                               		time(&AprsKeepAlive);
                               		AprsKeepAlive += 70;
                       		}
			}
			else
			{
                       		if (atime >= AprsKeepAlive)
                       		{
                               		ReConnectSet();
                               		break;
                       		}
			}
                       	if (BeaconInterval && verify_sw)
                       	{
                               	if (atime >= BeaconTime) BeaconSend();
                       	}
                       	next_beacon = beacon_pnt;
                       	while (next_beacon)
                       	{
                               	if (next_beacon->BeaconInterval)
                               	{
                                       	if (atime >= next_beacon->BeaconTime) Beacon_Send(next_beacon);
                               	}
                               	next_beacon = next_beacon->next;
                       	}

			break;

		case DPRS_NG:
			break;

		case DPRS_OPEN_AUTOLINK_WAIT:
			time (&atime);
			if ((atime - Timer) >= 5) 
			{
				if (RetryCnt > 0)
				{
                                	if (ReDprsConnectCnt++ > RetryCnt)
                                        {
                                                fprintf (log_file, "%24.24s APRS Server Down\n", ctime(&atime));
                                                fflush (log_file);
						DprsState = DPRS_NG;
						break;
                                        }
					time (&Timer);
					break;
				}
				DprsState = DPRS_OPEN_AUTOLINK_RESTART;
			}
			break;

		case DPRS_OPEN_AUTOLINK_START:
			ReDprsConnectCnt = 0;

		case DPRS_OPEN_AUTOLINK_RESTART:
			DprsState = DPRS_OPEN_AUTOLINK;
			aprs_status = -1;
			memcpy (aprs_server, "NONE\0", 5);
			verify_sw = FALSE;
			break;

   		case DPRS_OPEN_AUTOLINK:
			if(aprs_status < 0)
			{
                        	memset (&hints, 0x00, sizeof(hints));
				hints.ai_socktype = SOCK_STREAM;
                        	hints.ai_family = PF_UNSPEC;
				sprintf (PORT, "%d", aprs_port);
                        	if ((err = getaddrinfo (aprs_name, PORT, &hints, &aprs_addr)) != 0)
                        	{
					time(&atime);
                                	fprintf (log_file, "%24.24s getaddrinfo error(APRS Server) %s\n", 
						ctime(&atime), gai_strerror(err));
					fprintf (log_file, "%24.24s APRS Server Name : %s\n", ctime(&atime), aprs_name);
                                	fflush (log_file);
					if ((err == EAI_AGAIN) || (err == EAI_NONAME))
					{
						if (RetryCnt > 0)
						{
							aprs_port = 0;
							DprsState = DPRS_NG;
							break;
						}
						else
						{
							DprsState = DPRS_OPEN_AUTOLINK_WAIT;
							time(&Timer);
							break;
						}
					}
					else
					{
						aprs_port = 0;
						DprsState = DPRS_NG;
						break;
					}
                        	}
        			err = getnameinfo (aprs_addr->ai_addr, aprs_addr->ai_addrlen, 
					aprs_ip, sizeof(aprs_ip), NULL, 0,
                        		NI_NUMERICHOST | NI_NUMERICSERV);
        			if (err != 0)
        			{
                			fprintf (log_file, "%24.24s getnameinfo error : %s\n", 
						ctime(&atime), gai_strerror(err));
                			fflush (log_file);
        			}
	
				if((aprs_sd = socket(aprs_addr->ai_family, aprs_addr->ai_socktype, aprs_addr->ai_protocol)) < 0)
				{
                                        time (&atime);
                                        fprintf (log_file, "%24.24s D-PRS TCP socket not open\n", ctime(&atime));
                                        fflush (log_file);
					if (aprs_addr != NULL) freeaddrinfo (aprs_addr);
                                        DprsState = DPRS_NG;
					break;
                                }

				aprs_status = connect (aprs_sd, aprs_addr->ai_addr, aprs_addr->ai_addrlen);
				if (aprs_status < 0)
				{
					if (errno == ECONNREFUSED)
					{
                                        	time (&atime);
                                        	fprintf (log_file, "%24.24s connect error (APRS Server) %s\n",
                                                        ctime(&atime), strerror(errno));
                                        	fflush (log_file);
						DprsState = DPRS_OPEN_AUTOLINK_WAIT;
						time (&Timer);
						close (aprs_sd);
						aprs_sd = 0;
						break;
					}
					else
					{
						time (&atime);
						fprintf (log_file, "%24.24s connect error (APRS Server) %s\n", 
							ctime(&atime), strerror(errno));
						fflush (log_file);
						time(&atime);
						if((atime - Timer) >= 3)	/* wait 3 seconds */
						{
							if (ReDprsConnectCnt++ > 5)
							{
								DprsState = DPRS_OPEN_AUTOLINK_START;
								aprs_status = -1;
								ReDprsConnectCnt = 0;
								close (aprs_sd);
								aprs_sd = 0;
								break;
							}
							time(&Timer);;
							break;
						}
					}
					break;
				}
			}
			FD_SET (aprs_sd, &fd_save);
			DprsState = DPRS_OPEN_DONE_AUTOLINK;
			ReDprsConnectCnt = 0;
			time(&Timer);
			break;

   		case DPRS_OPEN_DONE_AUTOLINK:
               		if (FD_ISSET (aprs_sd, &read_set))
			{
				len = recvfrom (aprs_sd, DprsTemp, sizeof(DprsTemp), 0, NULL, NULL);
				if (len > 2)
				{
					if (!memcmp(DprsTemp, "# ", 2))
					{	
						DprsState = DPRS_ACCEPT;
						time(&AprsConnectTime);
					}
					break;
				}
			}
			time(&atime);
			if (RetryCnt > 0)
			{
				if ((atime - Timer) >= 5)	/* wait 5 seconds */
				{
					ReDprsConnectCnt++;
					if (ReDprsConnectCnt > RetryCnt)	// default 60   5 * 60 = 300 Sec.
					{
						fprintf (log_file, "%24.24s APRS Server Down\n", ctime(&atime));
						fflush (log_file);
						DprsState = DPRS_NG;
						break;
					}
					time (&Timer);
				}
			}
			else
			{
				if ((atime - Timer) >= 70)
				{
					DprsState = DPRS_OPEN_AUTOLINK_START;
					FD_CLR (aprs_sd, &fd_save);
					close (aprs_sd);
					aprs_sd = 0;
					if (aprs_addr != NULL) freeaddrinfo (aprs_addr);
				}
			}
			break;

		case DPRS_ACCEPT:
			time (&atime);
			fprintf (log_file, "%24.24s APRS Server Connected\n", ctime(&atime));
			fflush (log_file);
			AprsUserPassSend();
			DprsState = DPRS_LOOP;
			ReDprsConnectCnt = 0;
			time(&AprsKeepAlive);
			AprsKeepAlive += 70;
			time(&AprsVerifyTime);
			AprsVerifyTime += 10;
			break;
      	}
}

void	ReConnectSet (void)
{
        time_t  atime;

	if (AutoReLink)
	{
        	DprsState = DPRS_OPEN_AUTOLINK_START;
	}
	else
	{
		DprsState = DPRS_NG;
	}
	FD_CLR (aprs_sd, &fd_save);
       	close (aprs_sd);
	aprs_sd = 0;
	freeaddrinfo (aprs_addr);
       	time(&atime);
       	fprintf (log_file, "%24.24s APRS Server (%s) Disconnected\n", ctime(&atime), aprs_server);
        fflush (log_file);
	memcpy (aprs_server, "NONE\0", 5);
	verify_sw = FALSE;
        aprs_status = -1;
}

void	aprs_link_start(void)
{
	time_t	atime;

	DprsState = DPRS_OPEN_AUTOLINK_START;
	if (aprs_sd)
	{
		FD_CLR (aprs_sd, &fd_save);
        	close (aprs_sd);
		aprs_sd = 0;
	}
        time(&atime);
	fprintf (log_file, "%24.24s APRS Server (%s) Disconnected\n", ctime(&atime), aprs_server);
        fprintf (log_file, "%24.24s APRS Server ReConnect Start\n", ctime(&atime));
        fflush (log_file);
        aprs_status = -1;
}


int	aprs_submit_login (void)
{

        int     i, n;
	char	call[8];
	int	err;
	time_t	atime;
	struct	addrinfo	hints;
	char	PORT[8];
        memset (&hints, 0x00, sizeof(hints));
        hints.ai_socktype = SOCK_DGRAM;
        hints.ai_family = AF_INET;
        sprintf (PORT, "%d", aprs_port);
        if ((err = getaddrinfo (aprs_name, PORT, &hints, &aprs_addr)) != 0)
        {
                time(&atime);
                fprintf (log_file, "%24.24s getaddrinfo error(APRS Server) %s\n",
                        ctime(&atime), gai_strerror(err));
                fprintf (log_file, "%24.24s APRS Server Name : %s\n", ctime(&atime), aprs_name);
                fflush (log_file);
                return FALSE;
        }
        err = getnameinfo (aprs_addr->ai_addr, aprs_addr->ai_addrlen, aprs_ip, sizeof(aprs_ip), NULL, 0,
                        NI_NUMERICHOST | NI_NUMERICSERV);
        if (err != 0)
        {
                fprintf (log_file, "%24.24s getnameinfo error : %s\n", ctime(&atime), gai_strerror(err));
                fflush (log_file);
		return FALSE;
        }

        if((aprs_sd = socket(aprs_addr->ai_family, aprs_addr->ai_socktype, 0)) < 0)
        {
                time (&atime);
                fprintf (log_file, "%24.24s D-PRS TCP socket not open\n", ctime(&atime));
                fflush (log_file);
                freeaddrinfo (aprs_addr);
                return FALSE;
        }

        memset (call, 0x00, 8);
        memcpy (DprsTemp, "user ", 5);
        DprsTempPnt = 5;
        n = 0;
        for (i = 0 ; i < 7 ; i++)
        {
        	if (client_callsign[i] != 0x20)
                {
                	DprsTemp[DprsTempPnt++] = client_callsign[i];
                        call[n++] = client_callsign[i];
                }
                else
                {
                	if (DprsTempPnt > 0)
                        {
                        	if(DprsTemp[DprsTempPnt-1] != '-')
                                {
                                	DprsTemp[DprsTempPnt++] = '-';
                                }
                        }
                }
	}
        DprsTemp[DprsTempPnt++] = radio_id;
        DprsTemp[DprsTempPnt++] = 'S';
        memcpy (&DprsTemp[DprsTempPnt], " pass ", 6);
        DprsTempPnt += 6;
        sprintf (call, "%05d", passcode(call));
        call[5] = 0x00;
        memcpy (&DprsTemp[DprsTempPnt], call, 5);
        DprsTempPnt += 5;
        memcpy (&DprsTemp[DprsTempPnt], " vers D-STAR_X-change " , 22);
        DprsTempPnt += 22;
        memcpy (&DprsTemp[DprsTempPnt], PACKAGE_VERSION, 5);
        DprsTempPnt += 5;
        DprsTemp[DprsTempPnt++] = '-';
        memcpy (&DprsTemp[DprsTempPnt], uname_buf.machine,
        			strlen(uname_buf.machine));
        DprsTempPnt += strlen (uname_buf.machine);
        memcpy (&DprsTemp[DprsTempPnt], "\r\n", 2);
        DprsTempPnt += 2;

	return TRUE;
}

int	aprs_submit_send (char string[], int length)
{
	int	len;
	time_t	atime;

	if (!aprs_submit_login()) return FALSE;
	memcpy (&DprsTemp[DprsTempPnt], string, length);
	DprsTempPnt += length;
	DprsTemp[DprsTempPnt] = 0x00;
        if ((len = sendto (aprs_sd, DprsTemp, DprsTempPnt, 0, aprs_addr->ai_addr, aprs_addr->ai_addrlen)) <= 0)
        {
        	time(&atime);
                fprintf (log_file, "%24.24s Aprs submit port send error %s\n", ctime(&atime), strerror(errno));
                fflush (log_file);
	}
	freeaddrinfo (aprs_addr);
	close (aprs_sd);
	aprs_sd = 0;
	if (len > 0) return TRUE;
	else return FALSE;

}
