#include	"dxchange.h"

int      aprs_submit_login (void);

extern	int	DprsTempPnt;

void	BeaconSend(void)
{
	char	id[10];
	int	comment_len;
	int	i;
	int	k;
	int	save_pnt;
	time_t	atime;

	char	RadioLat[8], RadioLong[9];

	if (BeaconInterval <= 0) return;

	DprsTempPnt = 0;
	if (aprs_submit)
	{
		if (!aprs_submit_login()) return;
	}

	i = abs(BeaconLat) % 10000;
	i = i * 6 + 5;
	i /= 10;
	sprintf (RadioLat, "%02d%02d.%02d" ,abs(BeaconLat)/10000, i/100, i%100);
	if (BeaconLat >= 0) RadioLat[7] = 'N';
	else RadioLat[7] = 'S';

	i = abs(BeaconLong) % 10000;
	i = i * 6 + 5;
	i /= 10;
	sprintf (RadioLong, "%03d%02d.%02d",abs(BeaconLong)/10000, i/100, i%100);
	if (BeaconLong >= 0) RadioLong[8] = 'E';
	else RadioLong[8] = 'W';
    
	k = 0;
	for (i = 0 ; i < 7 ; i++)
	{
		if (client_callsign[i] != 0x20)
		{
			id[k] = client_callsign[i];
			k++;
		}
		else
		{
			if (k > 0)
			{
				if(id[k-1] != '-')
				{
					id[k] = '-';
					k++;
				}
			}
		}
	}
	id[k++] = radio_id;
	id[k] = 0x00;

	comment_len = strlen(beacon_comment);
	if (comment_len > 63) comment_len = 63;
	memcpy (&DprsTemp[DprsTempPnt], id, k);
	DprsTempPnt += k;
	memcpy (&DprsTemp[DprsTempPnt], ">APIRP2,TCPIP*,qAC,",19);
	DprsTempPnt += 19;
	memcpy (&DprsTemp[DprsTempPnt], id, k);
	DprsTempPnt += k;
	DprsTemp[DprsTempPnt++] = 'S';
	memcpy (&DprsTemp[DprsTempPnt], ":!", 2);
	save_pnt = DprsTempPnt + 1;
	DprsTempPnt += 2;
	memcpy (&DprsTemp[DprsTempPnt], RadioLat, 8);
	DprsTempPnt += 8;
	DprsTemp[DprsTempPnt++] = 'D';
	memcpy (&DprsTemp[DprsTempPnt], RadioLong, 9);
	DprsTempPnt += 9;
	DprsTemp[DprsTempPnt++] = '&';
	memcpy (&DprsTemp[DprsTempPnt], beacon_comment, comment_len);
	DprsTempPnt += comment_len;
	memcpy (&DprsTemp[DprsTempPnt], "\r\n", 2);
	DprsTempPnt += 2;
	if (aprs_submit)
	{
		sendto (aprs_sd, DprsTemp, DprsTempPnt, 0, aprs_addr->ai_addr, aprs_addr->ai_addrlen);
	}
	else
	{
		send (aprs_sd, DprsTemp,DprsTempPnt, 0);
	}
	memcpy (&DprsTemp[save_pnt], "<IGATE,MSG_CNT=0,LOC_CNT=1\r\n", 28);
	save_pnt += 28;
	if (aprs_submit)
	{
		sendto (aprs_sd, DprsTemp, save_pnt, 0, aprs_addr->ai_addr, aprs_addr->ai_addrlen);
	}
	else
	{
		send (aprs_sd, DprsTemp, save_pnt, 0);
	}
	BeaconTime += BeaconInterval;
	if (debug_sw)
	{
		time (&atime);
		fprintf (log_file, "%24.24s Beacon Sent\n", ctime(&atime));
		fflush (log_file);
	}
}



void	Beacon_Send(struct Beacon *pnt)
{
	char	id[10];
	int	comment_len;
	int	i;
	int	k;
	int	save_pnt;
	time_t	atime;

	char	RadioLat[8], RadioLong[9];

	if (pnt->BeaconInterval <= 0) return;

	DprsTempPnt = 0;

	i = abs(pnt->BeaconLat) % 10000;
	i = i * 6 + 5;
	i /= 10;
	sprintf (RadioLat, "%02d%02d.%02d" ,abs(pnt->BeaconLat)/10000, i/100, i%100);
	if (pnt->BeaconLat >= 0) RadioLat[7] = 'N';
	else RadioLat[7] = 'S';

	i = abs(pnt->BeaconLong) % 10000;
	i = i * 6 + 5;
	i /= 10;
	sprintf (RadioLong, "%03d%02d.%02d",abs(pnt->BeaconLong)/10000, i/100, i%100);
	if (pnt->BeaconLong >= 0) RadioLong[8] = 'E';
	else RadioLong[8] = 'W';
    
	k = 0;
	for (i = 0 ; i < 7 ; i++)
	{
		if (pnt->ModuleName[i] != 0x20)
		{
			id[k] = pnt->ModuleName[i];
			k++;
		}
		else
		{
			if (k > 0)
			{
				if(id[k-1] != '-')
				{
					id[k] = '-';
					k++;
				}
			}
		}
	}
	id[k++] = radio_id;
	id[k] = 0x00;

	comment_len = strlen(pnt->comment);
	if (comment_len > 63) comment_len = 63;
	memcpy (&DprsTemp[DprsTempPnt], id, k);
	DprsTempPnt += k;
	memcpy (&DprsTemp[DprsTempPnt], ">APIRP2,TCPIP*,qAC,",19);
	DprsTempPnt += 19;
	memcpy (&DprsTemp[DprsTempPnt], id, k);
	DprsTempPnt += k;
	DprsTemp[DprsTempPnt++] = 'S';
	memcpy (&DprsTemp[DprsTempPnt], ":!", 2);
	save_pnt = DprsTempPnt + 1;
	DprsTempPnt += 2;
	memcpy (&DprsTemp[DprsTempPnt], RadioLat, 8);
	DprsTempPnt += 8;
	DprsTemp[DprsTempPnt++] = 'D';
	memcpy (&DprsTemp[DprsTempPnt], RadioLong, 9);
	DprsTempPnt += 9;
	DprsTemp[DprsTempPnt++] = '&';
	memcpy (&DprsTemp[DprsTempPnt], pnt->comment, comment_len);
	DprsTempPnt += comment_len;
	memcpy (&DprsTemp[DprsTempPnt], "\r\n", 2);
	DprsTempPnt += 2;
	send (aprs_sd, DprsTemp,DprsTempPnt, 0);
	memcpy (&DprsTemp[save_pnt], "<IGATE,MSG_CNT=0,LOC_CNT=1\r\n", 28);
	save_pnt += 28;
	send (aprs_sd, DprsTemp, save_pnt, 0);
	pnt->BeaconTime += pnt->BeaconInterval;
	if (debug_sw)
	{
		time (&atime);
		fprintf (log_file, "%24.24s Beacon Sent (%8.8s) \n", ctime(&atime), pnt->ModuleName);
		fflush (log_file);
	}
}
