#include "dxchange.h"

int        send_check(char call_sign[]);
unsigned short int        update_crc_dstar( unsigned short int  crc, unsigned char c );
unsigned short int                result_crc_dstar(unsigned short int crc);
int	aprs_submit_send (char string[], int length);
void	send_check_reset (char call_sign[]);
void	ReConnectSet (void);

extern	int	aprs_sd;
extern	struct	addrinfo *aprs_addr;
extern	int	aprs_status;

int	GPS_A_SumCheck(char  string[])
{
	unsigned short int	crc_dstar_ffff, k, k0, k1, k2, k3;
	char	*pnt;
	
    	crc_dstar_ffff = 0xffff;	/* nornal value 0xffff */
	pnt = string + 10;

	while (*pnt != 0x0a)
	{
		if (*pnt == 0x00) return FALSE;
		crc_dstar_ffff = update_crc_dstar( crc_dstar_ffff, *pnt);
		pnt++;
	}

	crc_dstar_ffff = result_crc_dstar(crc_dstar_ffff);

	k0 = string[5] - '0';
	if (k0 > 16) k0 -= 7;
	k1 = string[6] - '0';
	if (k1 > 16) k1 -= 7;
	k2 = string[7] - '0';
	if (k2 > 16) k2 -= 7;
	k3 = string[8] - '0';
	if (k3 > 16) k3 -= 7;
	k1 += k0 * 16;
	k3 += k2 * 16;
    	k = k1 | (k3 << 8);

	if (k == crc_dstar_ffff) return TRUE;
	return	FALSE;
}

void	GPS_A_Send(char string[], struct ModuleTable *id)
{
	char	CallSign[10];
	int	i, k, n, tmp;
	int	len;
	time_t	atime;
	char	temp[20];
	char	string_temp[256];
	int	err;

	id->qsy_sw = TRUE;
	memset (CallSign, 0x20, 10);
	for (i = 0 ; i < 10 ; i++)
	{
		if (string[i] == 0x00) return;
		if (string[i] == '>') break;
		CallSign[i] = string[i];	
	}
	if (CallSign[0] == 0x20)
	{
		id->AprsSend = APRS_INVALID;
		memcpy (id->aprs_msg_save, id->aprs_msg, 256);
		return;	
	}
	for (i = 0 ; i < 10 ; i++)
	{
		if (string[i] == '-')
		{
			if (isalpha(string[i+1]))
			{
				id->qsy_sw = FALSE;
				break;
			}
		}
	}

	len = strlen((char *)string);
	memset (string_temp, 0x00, 256);
	memcpy (string_temp, string, len);
	for (i = 0 ; i < len ; i++)
	{
		if ((string[i] == '!') || (string[i] == 'z') || (string[i] == 'h') 
			|| (string[i] == '='))
		{
			memset (temp, 0x00, 20);
			n = 0;
			for (k = i+1 ; k < len ; k++)
			{
				temp[n] = string[k];
				if (!(isdigit(string[k]) || (string[k] == '.')
					|| (string[k] == 'S') || (string[k] == 'N')))
				{
					temp[n] = 0x00;
					tmp = atof (&temp[2]) * 10000. / 60.;
					temp[2] = 0x00;
					tmp = tmp + (atoi(temp) * 10000);
					if (temp[7] == 'S') tmp = - tmp;
					id->STATUS_Frm.body.status.Latitude = tmp;
					break;
				}
				n++;
			}
			if (isdigit(string[k]))		// IC-2820 bug
			{
				id->AprsSend = APRS_INVALID;
				return;
			}
			k++; 
                        memset (temp, 0x00, 20);
                        n = 0;
                        for ( ; k < len ; k++)
                        {
                                temp[n] = string[k];
				if (!(isdigit(string[k]) || (string[k] == '.') 
					|| (string[k] == 'W') || (string[k] == 'E')))
                                {
                                        temp[n] = 0x00;
                                        tmp = atof (&temp[3]) * 10000. / 60.;
                                        temp[3] = 0x00;
                                        tmp = tmp + (atoi(temp) * 10000);
                                        if (temp[8] == 'W') tmp = - tmp;
                                        id->STATUS_Frm.body.status.Longitude = tmp;
                                        break;
                                }
                                n++;
                        }
			k++;
			if (id->qsy_sw && qsy_info)
			{
				if (isdigit(string[k])) k += 7;
				if (string[k] == '/')
				{
					if (!memcmp (&string[k+1], "A=", 2)) k += 9;
					else k++;
				}
                        	if (len > k) memcpy (&string_temp[k+15], &string[k], len - k);
                        	memcpy (&string_temp[k], "D-STAR>", 7);
                        	memcpy (&string_temp[k+7], id->ModuleName, 8);
			}
			break;
		}
	}

        if (send_check(CallSign))
        {
		time (&atime);
		if (aprs_submit)
		{
			for (i = 0 ; i < strlen(string_temp) ; i++)
			{
				if (!memcmp (&string_temp[i], "DSTAR*", 6)) 
				{
					memcpy (&string_temp[i], "TCPIP*", 6);
					break;
				}
			}
			if (!aprs_submit_send (string_temp, strlen((char *)string_temp)))
			{
				send_check_reset (CallSign);
				id->AprsSend =  APRS_ERROR;	
			}
		}
		else
		{
                	err = send (aprs_sd, string_temp, strlen((char *)string_temp), 0);
        		if (err < 0)
        		{
                		fprintf (log_file, "%24.24s aprs send error %s\n", ctime(&atime), strerror(errno));
                		fflush (log_file);
				ReConnectSet();
				send_check_reset (CallSign);
				id->AprsSend =  APRS_ERROR;
				return;
			}
        	}
                fprintf (log_file, "%24.24s send : %s\n", ctime(&atime), string_temp);
                fflush (log_file);
                id->AprsSend =  APRS_SEND;
                aprs_cnt++;
                memcpy (id->aprs_msg_save, id->aprs_msg, 256);
        }
        else
        {
                id->AprsSend = APRS_SHORT;
                memcpy (id->aprs_msg_save, id->aprs_msg, 256);
        }	
}

void    gps_a (char msg[], struct ModuleTable *id)
{
	time_t	atime;

	if ((aprs_status < 0) && (aprs_submit == 0)) return;

	time(&atime);
        if (debug_sw)
	{
		fprintf (log_file, "%24.24s gps_a: %s", ctime(&atime), msg);
		fflush (log_file);
	}
        if (!GPS_A_SumCheck(msg))
	{
		id->AprsSend = APRS_ERROR;
		memcpy (id->aprs_msg_save, id->aprs_msg, 256);
		fprintf (log_file, "%24.24s CRC error : %s", ctime(&atime), msg);
		fflush (log_file);
		return;
	}
        if (!gps_only_skip || !id->RadioGpsSkip)
        {
	        if (verify_sw || aprs_submit) GPS_A_Send (&msg[10], id);
	}
	else
	{
		if (debug_sw)
		{
			fprintf (log_file, "%24.24s Skip GPS Message Only\n", ctime(&atime));
			fflush (log_file);
		}
	}
}

